using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;

namespace PersonDemo
{
    /// <summary>
    /// A form for entering data about a person and then adding and saving
    /// or loading or deleting a person.
    /// </summary>
    public class PersonForm : System.Windows.Forms.Form
    {
        private System.Windows.Forms.Label label1;
        private System.Windows.Forms.Label label2;
        private System.Windows.Forms.Label label3;
        private System.Windows.Forms.Label label4;
        private System.Windows.Forms.TextBox txtName;
        private System.Windows.Forms.TextBox txtBirthDate;
        private System.Windows.Forms.Button btnOK;
        private System.Windows.Forms.Button btnCancel;
        private System.Windows.Forms.Button btnApply;
        private System.Windows.Forms.Label lblAge;

        private System.Windows.Forms.Label label6;
        private System.Windows.Forms.TextBox txtSocialSecurityNumber;
        private System.Windows.Forms.Label lblSocialSecurityNumberLength;
        private System.Windows.Forms.Button btnLoadPerson;
        private System.Windows.Forms.CheckBox chkLoading;

        private System.Windows.Forms.Button btnDelete;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        // The business objects used by this form
        private Person person;
        
        // Caption for message boxes
        private const string messageCaption = "Person";
        
        // Is a Person being loaded from the database?
        // If a Person is being loaded it can't be edited.
        private bool isLoading;

        public PersonForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.label3 = new System.Windows.Forms.Label();
            this.btnCancel = new System.Windows.Forms.Button();
            this.txtBirthDate = new System.Windows.Forms.TextBox();
            this.lblAge = new System.Windows.Forms.Label();
            this.txtName = new System.Windows.Forms.TextBox();
            this.btnDelete = new System.Windows.Forms.Button();
            this.btnLoadPerson = new System.Windows.Forms.Button();
            this.lblSocialSecurityNumberLength = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.btnApply = new System.Windows.Forms.Button();
            this.btnOK = new System.Windows.Forms.Button();
            this.label4 = new System.Windows.Forms.Label();
            this.txtSocialSecurityNumber = new System.Windows.Forms.TextBox();
            this.chkLoading = new System.Windows.Forms.CheckBox();
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 128);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(56, 23);
            this.label3.TabIndex = 2;
            this.label3.Text = "Birth date";
            // 
            // btnCancel
            // 
            this.btnCancel.Location = new System.Drawing.Point(96, 208);
            this.btnCancel.Name = "btnCancel";
            this.btnCancel.TabIndex = 9;
            this.btnCancel.Text = "Cancel";
            this.btnCancel.Click += new System.EventHandler(this.btnCancel_Click);
            // 
            // txtBirthDate
            // 
            this.txtBirthDate.Location = new System.Drawing.Point(80, 128);
            this.txtBirthDate.Name = "txtBirthDate";
            this.txtBirthDate.TabIndex = 6;
            this.txtBirthDate.Text = "";
            this.txtBirthDate.TextChanged += new System.EventHandler(this.txtBirthDate_TextChanged);
            // 
            // lblAge
            // 
            this.lblAge.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.lblAge.Location = new System.Drawing.Point(80, 168);
            this.lblAge.Name = "lblAge";
            this.lblAge.Size = new System.Drawing.Size(64, 16);
            this.lblAge.TabIndex = 11;
            // 
            // txtName
            // 
            this.txtName.Location = new System.Drawing.Point(80, 88);
            this.txtName.Name = "txtName";
            this.txtName.Size = new System.Drawing.Size(136, 20);
            this.txtName.TabIndex = 5;
            this.txtName.Text = "";
            this.txtName.TextChanged += new System.EventHandler(this.txtName_TextChanged);
            // 
            // btnDelete
            // 
            this.btnDelete.Location = new System.Drawing.Point(240, 56);
            this.btnDelete.Name = "btnDelete";
            this.btnDelete.TabIndex = 16;
            this.btnDelete.Text = "Delete";
            this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
            // 
            // btnLoadPerson
            // 
            this.btnLoadPerson.Location = new System.Drawing.Point(152, 56);
            this.btnLoadPerson.Name = "btnLoadPerson";
            this.btnLoadPerson.TabIndex = 14;
            this.btnLoadPerson.Text = "Load";
            this.btnLoadPerson.Click += new System.EventHandler(this.btnLoadPerson_Click);
            // 
            // lblSocialSecurityNumberLength
            // 
            this.lblSocialSecurityNumberLength.Location = new System.Drawing.Point(184, 24);
            this.lblSocialSecurityNumberLength.Name = "lblSocialSecurityNumberLength";
            this.lblSocialSecurityNumberLength.Size = new System.Drawing.Size(96, 16);
            this.lblSocialSecurityNumberLength.TabIndex = 12;
            this.lblSocialSecurityNumberLength.Text = "Exactly 5 digits";
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(184, 128);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(100, 16);
            this.label6.TabIndex = 13;
            this.label6.Text = "(dd/mm/yyyy)";
            // 
            // btnApply
            // 
            this.btnApply.Location = new System.Drawing.Point(184, 208);
            this.btnApply.Name = "btnApply";
            this.btnApply.TabIndex = 10;
            this.btnApply.Text = "Apply";
            this.btnApply.Click += new System.EventHandler(this.btnApply_Click);
            // 
            // btnOK
            // 
            this.btnOK.Location = new System.Drawing.Point(8, 208);
            this.btnOK.Name = "btnOK";
            this.btnOK.TabIndex = 8;
            this.btnOK.Text = "OK";
            this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(8, 160);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(56, 23);
            this.label4.TabIndex = 3;
            this.label4.Text = "Age";
            // 
            // txtSocialSecurityNumber
            // 
            this.txtSocialSecurityNumber.Location = new System.Drawing.Point(80, 24);
            this.txtSocialSecurityNumber.Name = "txtSocialSecurityNumber";
            this.txtSocialSecurityNumber.TabIndex = 4;
            this.txtSocialSecurityNumber.Text = "";
            this.txtSocialSecurityNumber.TextChanged += new System.EventHandler(this.txtSocialSecurityNumber_TextChanged);
            // 
            // chkLoading
            // 
            this.chkLoading.Location = new System.Drawing.Point(80, 56);
            this.chkLoading.Name = "chkLoading";
            this.chkLoading.Size = new System.Drawing.Size(64, 24);
            this.chkLoading.TabIndex = 15;
            this.chkLoading.Text = "Loading";
            this.chkLoading.CheckedChanged += new System.EventHandler(this.chkLoading_CheckedChanged);
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 24);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(56, 40);
            this.label1.TabIndex = 0;
            this.label1.Text = "Social Security Number";
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 88);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(56, 23);
            this.label2.TabIndex = 1;
            this.label2.Text = "Name";
            // 
            // PersonForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(328, 253);
            this.Controls.AddRange(new System.Windows.Forms.Control[] {
                                                                          this.btnDelete,
                                                                          this.chkLoading,
                                                                          this.btnLoadPerson,
                                                                          this.label6,
                                                                          this.lblSocialSecurityNumberLength,
                                                                          this.lblAge,
                                                                          this.btnApply,
                                                                          this.btnCancel,
                                                                          this.btnOK,
                                                                          this.txtBirthDate,
                                                                          this.txtName,
                                                                          this.txtSocialSecurityNumber,
                                                                          this.label4,
                                                                          this.label3,
                                                                          this.label2,
                                                                          this.label1});
            this.Name = "PersonForm";
            this.Text = "Edit Person";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.PersonForm_Closing);
            this.Load += new System.EventHandler(this.PersonForm_Load);
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new PersonForm());
        }

        #region Event handlers
        
        private void PersonForm_Load(object sender, System.EventArgs e)
        {
			person = new Person();

			isLoading = false;

			UpdateEnableSave();
			lblSocialSecurityNumberLength.Text = 
				"Exactly " + 
				person.SocialSecurityNumberLength.ToString() + 
				" digits.";
			chkLoading.Checked = isLoading;
			btnLoadPerson.Enabled = false;
			btnDelete.Enabled = false;
            
			if (isLoading)
			{
				this.Text = "Load Person";
			}
			else
			{
				this.Text = "Edit Person";
				person.BeginEdit();
			}
			
			SubscribeToPersonEvents();
        }

        /// <summary>
        /// Toggles between loading and editing a Person.
        /// </summary>
        private void chkLoading_CheckedChanged(object sender, System.EventArgs e)
        {
            // Changing from non-loading to loading entails several things. 
            // For example, editing is invalidated and if Person is in a valid
            // state the user should be warned that they will lose their changes.
            isLoading = chkLoading.Checked;
            
            if (isLoading)
            {
				this.Text = "Load Person";
				
				if (person.IsEditing)
                {
                    if (person.IsValid)
                    {
                        if (MessageBox.Show("You are about to load a new person. Do you wish to save your changes?", 
                            messageCaption, MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.Yes)
                        {
                            person.ApplyEdit();
                        }
                    }

                    // Clear edits
                    txtSocialSecurityNumber.Clear();
                    txtName.Clear();
                    txtBirthDate.Clear();
                    
                    // Get a new Person
                    person = null;
                    person = new Person();
                    SubscribeToPersonEvents();
                }
            }
            else // Enable edit
            {
				this.Text = "Edit Person";
				
				person.BeginEdit();
                UpdateEnableDelete();
            }
            
            UpdateEnableLoad();
            
            // Toggle enabling of name and birth date
            // Enable social security
            txtName.Enabled = !isLoading;
            txtBirthDate.Enabled = !isLoading;
            txtSocialSecurityNumber.Enabled = true;
            txtSocialSecurityNumber.Focus();
        }

        /// <summary>
        /// Loads a Person.
        /// A Person is loaded based on a validly entered social security number.
        /// </summary>
        private void btnLoadPerson_Click(object sender, System.EventArgs e)
        {
            try
            {
                Trace.Assert(isLoading, "Must be in loading mode.");

                string socialSecurityNumber = txtSocialSecurityNumber.Text;
                Trace.Assert(Person.CheckValidSocialSecurityNumber(socialSecurityNumber), 
                    "Must be valid social security number.");
                person.Load(socialSecurityNumber);

                // Set retrieved values
                txtName.Text = person.Name;
                txtBirthDate.Text = person.BirthDate;
                lblAge.Text = person.Age.ToString();

                UpdateEnableSave();
                
                txtSocialSecurityNumber.Enabled = false;
                btnLoadPerson.Enabled = false;
                
                // Since loading a person resets all the fields
                // in the embedded Person object the Form needs
                // to resubscribe to Person events
                //SubscribeToPersonEvents();
            }
            catch (System.Exception ex)
            {
                DisplayError(ex);
                txtSocialSecurityNumber.Select();
            }
        }

        /// <summary>
        /// Deletes Person.
        /// A Person can only be deleted if it's not new.
        /// </summary>
        private void btnDelete_Click(object sender, System.EventArgs e)
        {
            try
            {
                Trace.Assert(!person.IsNew, "Can only delete old objects.");
                
                // Mark for deletion
                person.Delete();
                
                if (MessageBox.Show("This person will be deleted permanently. Are you sure you wish to proceed?", 
                    "Confirm Delete", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.Yes)
                {
                    person.ApplyEdit();
                    MessageBox.Show("Deleted.", messageCaption);
                }
                else
                {
                    person.CancelEdit();
                }
                
                person.BeginEdit();
                UpdateEnableDelete();
            }
            catch (System.Exception ex)
            {
                DisplayError(ex);
            }
        }

        /// <summary>
        /// Saves and finishes editing.
        /// </summary>
        private void btnOK_Click(object sender, System.EventArgs e)
        {
            try
            {
                person.ApplyEdit();
                // Calls Closing event, which has an implementation
                this.Close();
            }
            catch (System.Exception ex)
            {
                DisplayError(ex);
            }
        }

        private void btnCancel_Click(object sender, System.EventArgs e)
        {
            // Calls Closing event, which has an implementation
            this.Close(); 
        }

        /// <summary>
        /// Saves and continues editing.
        /// </summary>
        private void btnApply_Click(object sender, System.EventArgs e)
        {
            try
            {
                // Save
                person.ApplyEdit();
            
                // Disable Apply until input next changes
                btnApply.Enabled = false;

                // Re-enable editing
                person.BeginEdit();
            }
            catch (System.Exception ex)
            {
                DisplayError(ex);
            }
        }

        private void PersonForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (person.IsEditing)
            {
                person.CancelEdit();
            }
        }

        private void txtSocialSecurityNumber_TextChanged(object sender, System.EventArgs e)
        {
            UpdateEnableDelete();
            
            if (isLoading)
            {
                UpdateEnableLoad();
            }
            else // Editing
            {
                try
                {
                    person.SocialSecurityNumber = txtSocialSecurityNumber.Text;
                }
                catch (System.Exception ex)
                {
                    DisplayError(ex);
                }
            }
        }

        private void txtName_TextChanged(object sender, System.EventArgs e)
        {
            if (!isLoading)
            {
                try
                {
                    person.Name = txtName.Text;
                }
                catch (System.Exception ex)
                {
                    DisplayError(ex);
                }
            }
        }

        private void txtBirthDate_TextChanged(object sender, System.EventArgs e)
        {
            if (!isLoading)
            {
                try
                {
                    person.BirthDate = txtBirthDate.Text;
                }
                catch (System.Exception ex)
                {
                    DisplayError(ex);
                }
            }
        }
        
        /// <summary>
        /// Subscribes to Person events.
        /// </summary>
        private void SubscribeToPersonEvents()
        {
            person.OnNewAge += new Person.EventHandler(Person_OnNewAge);
            person.OnValid += new Person.EventHandler(Person_OnValid);
            person.OnInvalid += new Person.EventHandler(Person_OnInvalid);
        }

        // Person events

        private void Person_OnNewAge(object sender, System.EventArgs e)
        {
            // Update the displayed age
            lblAge.Text = person.Age.ToString();
        }

        private void Person_OnValid(object sender, System.EventArgs e)
        {
            UpdateEnableSave();
        }

        private void Person_OnInvalid(object sender, System.EventArgs e)
        {
            UpdateEnableSave();
        }
        
        #endregion // Event handlers

        #region Implementation
        
        /// <summary>
        /// Enables/Disables OK and Apply buttons.
        /// </summary>
        private void UpdateEnableSave()
        {
            btnOK.Enabled = person.IsEditing && person.IsValid;
            btnApply.Enabled = person.IsEditing && person.IsValid;
        }
        
        /// <summary>
        /// Enables/Disables Load button.
        /// </summary>
        private void UpdateEnableLoad()
        {
            btnLoadPerson.Enabled = 
                isLoading && !person.IsEditing && person.IsNew && 
                Person.CheckValidSocialSecurityNumber(txtSocialSecurityNumber.Text);
        }
        
        /// <summary>
        /// Enables/Disables Delete button.
        /// </summary>
        private void UpdateEnableDelete()
        {
            btnDelete.Enabled = 
                person.IsEditing && !person.IsNew && 
                Person.CheckValidSocialSecurityNumber(txtSocialSecurityNumber.Text);
        }
        
        /// <summary>
        /// Displays exception message.
        /// </summary>
        /// <param name="ex">Exception.</param>
        private void DisplayError(System.Exception ex)
        {
            MessageBox.Show(ex.GetType() + "\n\n" + 
                ex.Message + "\n\n" + 
                ex.StackTrace, 
                messageCaption);
        }

        #endregion // Implementation
    }
}
